'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _postcssImport = require('postcss-import');

var _postcssImport2 = _interopRequireDefault(_postcssImport);

var _postcssCssnext = require('postcss-cssnext');

var _postcssCssnext2 = _interopRequireDefault(_postcssCssnext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  context: _path2.default.resolve(process.cwd(), './src'),
  distOutput: '/public',
  jsPath: 'js',
  cssPath: 'css',
  publicPath: '/assets/',
  indexFile: 'index.html',
  staticAssetsPath: '/public/assets',
  localIdentName: '[name]__[local]',
  autoPrefixer: ['last 2 versions'],
  devCssBundle: 'styles.bundle.css',
  prodCssBundle: 'styles.[contenthash:8].bundle.css',
  diagnostics: {
    heartbeat: '/diagnostic/heartbeat',
    version: '/diagnostic/version'
  },
  isDevEnvironment: process.env.NODE_ENV !== 'production',

  //  Loader configs
  babelLoaderConfig: {
    babelrc: false,
    presets: ['es2015', 'react', 'stage-0'],
    plugins: ['transform-regenerator']
  },
  fileLoaderConfig: {
    name: '[name].[hash].[ext]',
    outputPath: '/images'
  },
  postCssLoaderPlugins: [(0, _postcssImport2.default)({
    addDependencyTo: _webpack2.default
  }), (0, _postcssCssnext2.default)()]
};