'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _messaging = require('./../tools/messaging');

var _staticHandler = require('./handlers/staticHandler');

var _staticHandler2 = _interopRequireDefault(_staticHandler);

var _errorHandler = require('./handlers/errorHandler');

var _errorHandler2 = _interopRequireDefault(_errorHandler);

var _middleware = require('./middleware');

var _middleware2 = _interopRequireDefault(_middleware);

var _hooks = require('./../tools/hooks');

var _hooks2 = _interopRequireDefault(_hooks);

var _defaultConfig = require('./defaultConfig');

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

//  Run hooks before
//  starting application
(0, _hooks2.default)();

var Server = function () {
  function Server(config) {
    _classCallCheck(this, Server);

    this.config = _extends({}, _defaultConfig2.default, config);
    this.app = (0, _staticHandler2.default)((0, _express2.default)(), this.config);
  }

  _createClass(Server, [{
    key: 'create',
    value: function create(callback) {
      var app = this.app;
      var config = this.config;
      var port = config.port,
          diagnostics = config.diagnostics;


      app.get(diagnostics.heartbeat, function (req, res) {
        return res.send('OK');
      });

      app.get(diagnostics.version, function (req, res) {
        return res.send(process.env.APP_VERSION || '0.0.0');
      });

      app.use((0, _middleware2.default)(app, config), function (req, res) {
        return res.send(app.locals.output);
      });

      app.use(_errorHandler2.default);

      app.listen(port || 3000, function () {
        console.log((0, _messaging.getMessage)('welcome', config));
        if (callback && typeof callback === 'function') {
          callback();
        }
      });

      return app;
    }
  }]);

  return Server;
}();

exports.default = Server;