//  @flow
type RouteParams = { [string]: any };

const hasInitialFetch = fn => (typeof fn === 'function');

const fetchInitialProps = (getInitialProps: Function, routeParams: RouteParams): Object => (
  hasInitialFetch(getInitialProps)
    ? Promise.resolve(getInitialProps(routeParams))
    : Promise.resolve(null)
);

export default fetchInitialProps;
